#include <sourcemod>
#include <sdktools>
#include <multicolors>
#include <autoexecconfig>

#pragma semicolon 1

#define DEBUG

#pragma newdecls required

//DISABLE FUNCIONS
ConVar gConVar_BhopWhenRoundEnd;
ConVar gConVar_BhopRoundStaff;

//BHOP WHEN ROUND END
ConVar gConVar_RoundStartMessage;
ConVar gConVar_RoundEndMessage;

//BHOP ROUND FOR STAFF
ConVar gConVar_ForceStartMessage;
ConVar gConVar_ForceStopMessage;
ConVar gConVar_FinishRoundMessage;

//JOIN MSG
ConVar gConVar_JoinMsg;

bool BhopRound = false;

public Plugin myinfo = 
{
	name = "Bhop Round & Bhop When Round End", 
	author = "LanteJoula", 
	description = "Bhop Round & Bhop When Round End", 
	version = "1.3", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

public void OnPluginStart()
{
	LoadTranslations("bhopround-bhopwhenroundend.phrases");
	
	HookEvent("round_start", OnRoundStart);
	HookEvent("round_end", OnRoundEnd);
	HookEvent("round_end", OnRoundEndX);
	
	RegAdminCmd("sm_bhop", CMD_BHOP, ADMFLAG_GENERIC, "Open Menu for Bhop Round");
	
	AutoExecConfig_SetFile("plugin.bhopround-bhopwhenroundend");
	
	//DISABLE FUNCIONS
	gConVar_BhopWhenRoundEnd = AutoExecConfig_CreateConVar("sm_bhopwhenroundend", "1", "Enable/Disable the Function of Bhop When Round End (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_BhopRoundStaff = AutoExecConfig_CreateConVar("sm_bhoproundstaff", "1", "Enable/Disable the Function of Bhop Round for Staff on !bhop Menu (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	//BHOP WHEN ROUND END
	gConVar_RoundStartMessage = AutoExecConfig_CreateConVar("sm_roundstart_message", "1", "Enable/Disable the Message when Round Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_RoundEndMessage = AutoExecConfig_CreateConVar("sm_roundend_message", "1", "Enable/Disable the Message when Round End (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	//BHOP ROUND FOR STAFF
	gConVar_ForceStartMessage = AutoExecConfig_CreateConVar("sm_forcestart_message", "1", "Enable/Disable the Message on BHOP Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_ForceStopMessage = AutoExecConfig_CreateConVar("sm_forcestop_message", "1", "Enable/Disable the Message when Staff Force Stop the Bhop Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_FinishRoundMessage = AutoExecConfig_CreateConVar("sm_finishround_message", "1", "Enable/Disable the Message when Round End (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	//JOIN MSG
	gConVar_JoinMsg = AutoExecConfig_CreateConVar("z_join_message", "1", "Enable/Disable the Message when Player Join (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	//DISABLE CONVARS ON CHAT
	HookEvent("server_cvar", SilentEvent, EventHookMode_Pre);
}

/////////////////////
//BHOP WHEN ROUND END
/////////////////////

public Action OnRoundStart(Event event, const char[] name, bool dontBroadcast)
{
	if (gConVar_BhopWhenRoundEnd.BoolValue)
	{
		SetDefaultValue("sv_enablebunnyhopping");
		SetDefaultValue("sv_autobunnyhopping");
		SetDefaultValue("sv_staminamax");
		SetDefaultValue("sv_airaccelerate");
		SetDefaultValue("sv_staminajumpcost");
		SetDefaultValue("sv_staminalandcost");
		
		if (gConVar_RoundEndMessage.BoolValue)
			CPrintToChatAll("%t %t", "Prefix", "Round Start");
	}
}

public Action OnRoundEnd(Event event, const char[] name, bool dontBroadcast)
{
	if (gConVar_BhopWhenRoundEnd.BoolValue)
	{	
		SetCvar("sv_enablebunnyhopping", "1");
		SetCvar("sv_autobunnyhopping", "1");
		SetCvar("sv_staminamax", "0");
		SetCvar("sv_airaccelerate", "500");
		SetCvar("sv_staminajumpcost", "0");
		SetCvar("sv_staminalandcost", "0");
		
		if (gConVar_RoundStartMessage.BoolValue)
			CPrintToChatAll("%t %t", "Prefix", "Round End");
	}
}

/////////////////////////
//DISABLE CONVARS ON CHAT
/////////////////////////

public Action SilentEvent(Event event, const char[] name, bool dontBroadcast)
{
	SetEventBroadcast(event, true);
	return Plugin_Continue;
}

///////////////////
//AUTO JOIN MESSAGE
///////////////////

public void OnClientPutInServer(int client)
{
	CreateTimer(5.0, JoinMsg, client);
}

public Action JoinMsg(Handle timer, any client)
{
	if (gConVar_JoinMsg.BoolValue)
		CPrintToChat(client, "%t %t", "Prefix", "JoinMsg");
}

//////
//MENU
//////

public Action CMD_BHOP(int client, int args)
{
	if (gConVar_BhopRoundStaff.BoolValue)
		ShowMenu(client);
}

void ShowMenu(int client)
{
	char ForceStart[128];
	char ForceEnd[128];
	
	Menu menu = new Menu(Menu_Handler);
	menu.SetTitle("%t", "MenuTitle");
	if (!BhopRound)
	{
		Format(ForceStart, sizeof(ForceStart), "%t", "MenuForceStart");
		menu.AddItem("1", ForceStart);
	}
	else
	{
		Format(ForceEnd, sizeof(ForceEnd), "%t", "MenuForceEnd");
		menu.AddItem("2", ForceEnd);
	}
	menu.ExitButton = true;
	menu.Display(client, MENU_TIME_FOREVER);
}

public int Menu_Handler(Menu menu, MenuAction action, int client, int args)
{
	if (action == MenuAction_Select)
	{
		char selectedItem[200];
		menu.GetItem(args, selectedItem, sizeof(selectedItem));
		if (StrEqual(selectedItem, "1"))
		{
			BhopRound = true;
			
			SetCvar("sv_enablebunnyhopping", "1");
			SetCvar("sv_autobunnyhopping", "1");
			SetCvar("sv_staminamax", "0");
			SetCvar("sv_airaccelerate", "500");
			SetCvar("sv_staminajumpcost", "0");
			SetCvar("sv_staminalandcost", "0");
			
			if (gConVar_ForceStartMessage.BoolValue)
				CPrintToChatAll("%t %t", "Prefix", "Bhop Round Force Start");
		}
		if (StrEqual(selectedItem, "2"))
		{
			BhopRound = false;
			
			SetDefaultValue("sv_enablebunnyhopping");
			SetDefaultValue("sv_autobunnyhopping");
			SetDefaultValue("sv_staminamax");
			SetDefaultValue("sv_airaccelerate");
			SetDefaultValue("sv_staminajumpcost");
			SetDefaultValue("sv_staminalandcost");
			
			char name[128];
			GetClientName(client, name, sizeof(name));
			
			if (gConVar_ForceStopMessage.BoolValue)
				CPrintToChatAll("%t %t", "Prefix", "Bhop Round Force Stop", name);
		}
	}
	else if (action == MenuAction_End)
	{
		delete menu;
	}
}


public Action OnRoundEndX(Event event, const char[] name, bool dontBroadcast)
{
	if (BhopRound)
	{
		BhopRound = false;
		
		SetDefaultValue("sv_enablebunnyhopping");
		SetDefaultValue("sv_autobunnyhopping");
		SetDefaultValue("sv_staminamax");
		SetDefaultValue("sv_airaccelerate");
		SetDefaultValue("sv_staminajumpcost");
		SetDefaultValue("sv_staminalandcost");
		
		if (gConVar_FinishRoundMessage.BoolValue)
			CPrintToChatAll("%t %t", "Prefix", "Finish Bhop Round");
	}
}

//SETCVAR AND SETDEFAULTVALUE

stock void SetCvar(const char[] scvar, const char[] svalue)
{
	ConVar cvar = FindConVar(scvar);
	if (cvar == INVALID_HANDLE)
		return;

	SetConVarString(cvar, svalue, true);
}

stock void SetDefaultValue(char[] scvar)
{
	ConVar cvar = FindConVar(scvar);
	if (cvar == INVALID_HANDLE)
		return;
	
	char szDefault[100];
	cvar.GetDefault(szDefault, sizeof(szDefault));
	
	SetConVarString(cvar, szDefault, true);
} 